#include <tangle/tangle.h>

int main(int argc, char** argv) {
	ClutterActor* stage;
	ClutterActor* widget;
	guint x, y;
	ClutterActor* texture;
	ClutterActor* scrolling_actor;
	ClutterActor* horizontal_scrollbar;
	ClutterActor* vertical_scrollbar;
	ClutterColor color = { 0, 0, 128, 255 };
	
	tangle_init(&argc, &argv);
	stage = clutter_stage_get_default();
	clutter_actor_set_size(stage, 800.0, 400.0);

	widget = tangle_widget_new();
	for (x = 0; x < 20; x++) {
		for (y = 0; y < 10; y++) {
			texture = clutter_texture_new_from_file("test_image_135x100.jpg", NULL);
			clutter_actor_set_position(texture, x * 130.0, y * 100.0);
			clutter_container_add_actor(CLUTTER_CONTAINER(widget), texture);
		}
	}
	clutter_actor_set_size(widget, 20 * 130.0, 10 * 100.0);
	
	scrolling_actor = tangle_scrolling_actor_new(widget);
	clutter_actor_set_position(scrolling_actor, 100.0, 50.0);
	clutter_actor_set_size(scrolling_actor, 500.0, 300.0);
//	g_object_set(scrolling_actor, "max-overshoot-x", 250.0, "max-overshoot-y", 150.0, "repeat-x", TRUE, "repeat-y", TRUE, NULL);
	g_object_set(scrolling_actor, "repeat-x", TRUE, "repeat-y", TRUE, "continuous-x", TRUE, "continuous-y", TRUE, NULL);
//	g_signal_connect(scrolling_actor, "clamp-scrolling-offset-x", G_CALLBACK(tangle_scrolling_actor_clamp_page_boundaries), NULL);
	g_signal_connect_swapped(scrolling_actor, "clamp-scrolling-offset-x", G_CALLBACK(tangle_widget_clamp_child_boundaries), widget);
	g_signal_connect_swapped(scrolling_actor, "clamp-scrolling-offset-y", G_CALLBACK(tangle_widget_clamp_child_boundaries), widget);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), scrolling_actor);
	
	horizontal_scrollbar = tangle_scrollbar_new_rectangle(FALSE, &color);
	tangle_scrollbar_bind_to_scrolling_actor(TANGLE_SCROLLBAR(horizontal_scrollbar), TANGLE_SCROLLING_ACTOR(scrolling_actor));
	clutter_actor_set_position(horizontal_scrollbar, 100.0, 350.0);
	clutter_actor_set_size(horizontal_scrollbar, 500.0, 10.0);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), horizontal_scrollbar);

	vertical_scrollbar = tangle_scrollbar_new_rectangle(TRUE, &color);
	tangle_scrollbar_bind_to_scrolling_actor(TANGLE_SCROLLBAR(vertical_scrollbar), TANGLE_SCROLLING_ACTOR(scrolling_actor));
	clutter_actor_set_position(vertical_scrollbar, 600.0, 50.0);
	clutter_actor_set_size(vertical_scrollbar, 10.0, 300.0);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), vertical_scrollbar);
	
	clutter_actor_show_all(stage);	
	clutter_main();

	return 0;
}
